#include <pic.h>
#include <pic16f77.h>
__CONFIG(0x0319A);
//resonator 18.432Mgz
unsigned char d1,d2,d3,d4, 				//  1-  7 
			  d5,d6,d7,d8,				//  2-  7 
//			  dp1 = 2,dp2 = 6,					//   1  2  
			  vn;						//   TMR0
unsigned int	v11=0,v22=0,v1=0,v2=0;

void low_init()
	{
		ADCON0=0b10000101;
/*		         7||||||| - ADCS1 - 00 = fosc/2;01 = fosc/8;10 = fosc/32;11 = fosc in rc;
		          6|||||| - ADCS0 - //-
		           5||||| - CHS2  - Analog Channel Select bits
		            4|||| - CHS1  - Analog Channel Select bits
		             3||| - CHS0  - Analog Channel Select bits
			          2||- GO/DONE
			           1|  Unimplemented 0
			            0 - ADON

			CHS2:CHS0: Analog Channel Select bits
			000 = Channel 0 (RA0/AN0)
			001 = Channel 1 (RA1/AN1)
			010 = Channel 2 (RA2/AN2)
			011 = Channel 3 (RA3/AN3)
			100 = Channel 4 (RA5/AN4)
			101 = Channel 5 (RE0/AN5)(1)
			110 = Channel 6 (RE1/AN6)(1)
			111 = Channel 7 (RE2/AN7)(1)
*/
		ADCON1=0b00000001; 
/*		         7||||||| -
		          6|||||| -
		           5||||| -
		            4|||| -
		             3||| -
			          2|| - PCFG2
			           1| - PCFG1
			            0 - PCFG0 RA0~RA5,RE0~RE2   RA3 = Vref;
*/			
				
			OPTION_REG=0b00000100; 	//	 TMR0
			INTCON=0b10100100; 	//	 

			T0IE=1;
			T0IF=0;
			
			
			
			TRISA=0b11111111;  //   ,   
			TRISB=0b00000000;
			TRISD=0b00000000;
			TRISC=0x00000000;			
	vn=0;
PORTC=0;
	}


void delay(unsigned int p)	{	unsigned int i;	for(i=0;i<p;i++){asm("NOP");}}

void seg7(char c,char s,char dp)   //c-  0,,9,,; s-  ; dp -   ?
	{
			unsigned char t=0;

			switch(s)
				{
				case 1 :{	t=1;}break;
				case 2 :{	t=2;}break;
				case 3 :{	t=4;}break;
				case 4 :{	t=8;}break;
				case 5 :{	t=16;}break;
				case 6 :{	t=32;}break;
				case 7 :{	t=64;}break;
				case 8 :{	t=128;}break;
//				case 9 :{	t=255;}break;
				}
			
			switch(c)
				{		//		  ADEFG.CB
				case 0 : {PORTB=0b00001000;PORTD=t;}break;
				case 1 : {PORTB=0b11111000;PORTD=t;}break;
				case 2 : {PORTB=0b00010010;PORTD=t;}break;
				case 3 : {PORTB=0b00110000;PORTD=t;}break;
				case 4 : {PORTB=0b11100000;PORTD=t;}break;
				case 5 : {PORTB=0b00100001;PORTD=t;}break;
				case 6 : {PORTB=0b00000001;PORTD=t;}break;
				case 7 : {PORTB=0b01111000;PORTD=t;}break;
				case 8 : {PORTB=0b00000000;PORTD=t;}break;
				case 9 : {PORTB=0b00100000;PORTD=t;}break;
					//			  ADEFG.CB
				case 10 :{PORTB=0b10011001;PORTD=t;}break;		//U 
				case 11 :{PORTB=0b11010001;PORTD=t;}break;		//A
				} 
if (dp<1){PORTB=PORTB|0b00000100;};								//
	}

void interrupt isr(void)
//void isr(void)
	{
			if(T0IF) 	//	  TMR1
			{
				vn++;
			 	if ((vn==1&d1==0)){vn++;};  //  |(vn==5&d5==0)

			switch(vn)
				{
				case 1 : {seg7(d1,1,0);}break;
				case 2 : {seg7(d2,2,1);}break;
				case 3 : {seg7(d3,3,0);}break;
				case 4 : {seg7(10,4,0);}break; // u

				case 5 : {seg7(d5,5,1);}break;
				case 6 : {seg7(d6,6,0);}break;
				case 7 : {seg7(d7,7,0);}break;
//				case 8 : {seg7(d8,8,0);}break;
				case 8 : {seg7(11,8,0);}break;	//a	

				}	
			}
if (vn>8){vn=0;};				
		TMR0=1;
		T0IF=0; 	//	 
}


void main()
		{
		unsigned int i,n1,n2,n3,n4,m1,m2,m3,m4;
				low_init();

				while(1)
				{	
					//			 		 __xxxy_z xxx  0, y = GO_DONE=1; ADON=1;		//	  GO       
					
					
					
					CHS2=0;CHS1=0;CHS0=0;							//  AN0   		{U}
					i=0;
					while(i<500)										//  
							{//			delay(100);
										GO_DONE=1;					//  GO       
										while(GO_DONE&&ADIF){;};	//        
										v11=ADRES;					//   
					//					n1=n2;n2=n3;n3=n4;n4=v11;   // 
					//					v1=(n1+n2+n3+n4)/4;
										v1=(v1+v11)/2;
					i++;
					
							};
					
					
					
					CHS2=0;CHS1=0;CHS0=1;							// AN1   
					i=0;											//      {A}
					while(i<500)
							{//			delay(100);
										GO_DONE=1;	
										while(GO_DONE&&ADIF){;};
										v22=ADRES;		
					//					m1=m2;m2=m3;m3=m4;m4=v22;
					//					v2=(m1+m2+m3+m4)/4;
										v2=(v2+v22)/2;
										i++;
							};
					v2*=2;
							
					//					d4=v1%10;			//	    1  
					//					v1=v1/10;
										d3=v1%10;			
										v1=v1/10;
										d2=v1%10;
										d1=v1/10;
								
					//					d8=v2%10;			//	    2  
					//					v2=v2/10;
										d7=v2%10;			
										v2=v2/10;
										d6=v2%10;
										d5=v2/10;
					
				}
}


//  = 2,55; 
//  = 2,55/255 = 0,01/ 
//  5  1/2  0,02/
//  10  1/4  0,04/
//  10  1/4  0,04/
//  50  1/20  0,2/
//  100  1/40  0,4/
//  1000  1/400  4/





/*
unsigned char 
digits[2][16] = {
		//			  ADEFG_CB
					0b00001100,	// 0
					0b11111100,	// 1
					0b00010110, // 2
					0b00110100,	// 3
					0b11100100,	// 4
					0b00100101,	// 5
					0b00000101,	// 6
					0b01111100,	// 7
					0b00000100,	// 8
					0b00100100,	// 9
					0b01000100,	// A
					0b10000101,	// B
					0b00001111,	// C
					0b10010100,	// D
					0b00000111,	// E
					0b01000111,	// F
		
					0b00001000,	// 0.
					0b11111000,	// 1.
					0b00010010, // 2.
					0b00110000,	// 3.
					0b11100000,	// 4.
					0b00100001,	// 5.
					0b00000001,	// 6.
					0b01111000,	// 7.
					0b00000000,	// 8.
					0b00100000,	// 9.
					0b01000000,	// A.
					0b10000001,	// B.
					0b00001011,	// C.
					0b10010000,	// D.
					0b00000011,	// E.
					0b01000011	// F.
				},
//  
//  1 2 3 4		5 6 7 8

number [8] = {
					0b00000001,	//  1 
					0b00000010, //  2 
					0b00000100,	//
					0b00001000,	//
					0b00010000,	//
					0b00100000,	//
					0b01000000,	//
					0b10000000,	//  8 
			};



			//PORTB=0b11111111;
			//PORTB=digits[0][c%10]; PORTD=number[s-1];


if (seg1<1000){											//   1 ?
			if (seg1<100){		
						if (seg1<10){dp1=3;}			//0.000
				  dp1=2;}				 				//00.00
	   dp1=1;}											//000.0	
	  {dp1=0;};											//0000



				//if (n2<9999){n2++;};
				//if (n2>=9999){n1++;n2=0; };
				//if (n1>=9999&&n2>=9999){n2=0;n1=0;}
				//v1 = n1; v2 = n2;


*/